#include "libgraph.h"
#include <alloc.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>


/* Time */



value mltime ()    /* ML */
{
  struct tm *ltime;
  time_t t;
  value res;

  t=time(NULL);
  ltime=localtime(&t);

  res = alloc_tuple(7);
  Field(res, 0) = Val_int(ltime->tm_sec);
  Field(res, 1) = Val_int(ltime->tm_min);
  Field(res, 2) = Val_int(ltime->tm_hour);
  Field(res, 3) = Val_int(ltime->tm_mday);
  Field(res, 4) = Val_int(ltime->tm_mon);
  Field(res, 5) = Val_int(ltime->tm_year+1900);
  Field(res, 6) = Val_int(t);

  return res;
}


/* File stat */


value file_modif_time (file)    /* ML */
  value file;
{
  struct tm *ltime;
  struct stat buf;
  value res;


  if(stat(String_val(file),&buf)==-1)
  {
    gr_fail("can't execute file_modif_time",NULL);
    return Val_unit;
  }

  ltime=localtime(&buf.st_mtime);

  res = alloc_tuple(7);
  Field(res, 0) = Val_int(ltime->tm_sec);
  Field(res, 1) = Val_int(ltime->tm_min);
  Field(res, 2) = Val_int(ltime->tm_hour);
  Field(res, 3) = Val_int(ltime->tm_mday);
  Field(res, 4) = Val_int(ltime->tm_mon);
  Field(res, 5) = Val_int(ltime->tm_year+1900);
  Field(res, 6) = Val_int(buf.st_mtime);
  return res;
}

